#include "stdafx.h"

#include <windows.h>
#include <iostream>

using namespace std;

const int NUMERO_HILOS = 10;
const int NUMERO_ITERACIONES = 1000;

int Contador;

DWORD WINAPI RutinaDelHilo(LPVOID lpParam) 
{ 
	int j;

	for (j = 0; j < NUMERO_ITERACIONES; j++)
	{
		Contador = Contador * 2;
		Contador = Contador / 2;
		Contador = Contador + 1;
		Contador = Contador - 1;
	}
	return 0;
} 

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hThread[NUMERO_HILOS]; 
	DWORD dwThreadId[NUMERO_HILOS];
	int i;

	Contador = 0;
	for (i = 0; i < NUMERO_HILOS; i++)
	{
		hThread[i] = CreateThread( 
			NULL,								// Atributos de  seguridad
			0,									// Tamao de la pila por defecto
			RutinaDelHilo,			// Direccin de la rutina
			NULL,								// Argumento a la rutina 
			CREATE_SUSPENDED,		// Opciones de creacin 
			&(dwThreadId[i]));  // Retorna el identificador del hilo
			
		if (hThread[i] == NULL)
		{
			cerr << "Error en la creacin del hilo "
				<< GetLastError() << endl;
			return 1;
		}
	}
	
	for (i = 0; i < NUMERO_HILOS; i++)
		ResumeThread(hThread[i]);

	for (i = 0; i < NUMERO_HILOS; i++)
	{
		if (WaitForSingleObject(hThread[i], INFINITE) == WAIT_FAILED)
		{
			cerr << "Error durante la espera del hilo hijo: "
				<< GetLastError() << endl;
			return 1;
		}
	}
	
	for (i = 0; i < NUMERO_HILOS; i++)
		CloseHandle(hThread[i]);

	cout << "El valor de la variable contador es " << Contador << endl;

	return 0;
} 
